<?php namespace masterTheme;




add_action("head_start", "\masterTheme\mt_head_title", 10);
function mt_head_title()
{
	?><title><?=apply_filters("page_title", get_the_title())?></title><?php
}

add_action("head_start", "\masterTheme\mt_head_charset", 20);
function mt_head_charset()
{
	?><meta charset="<?=apply_filters("page_charset", bloginfo("charset"))?>"><?php
}

add_action("head_start", "\masterTheme\mt_head_viewport", 30);
function mt_head_viewport()
{
	?><meta name="viewport" content="<?=apply_filters("page_viewport", "width=device-width, initial-scale=1")?>"><?php
}

add_action("head_start", "\masterTheme\mt_head_description", 40);
function mt_head_description()
{
	?><meta name="description" content="<?=apply_filters("page_description", wp_strip_all_tags(get_the_excerpt()), true)?>"><?php
}


add_action("head_start", "\masterTheme\mt_head_keywords", 50);
function mt_head_keywords()
{
	$keywords = apply_filters("page_keywords", get_the_tags()) ?: array();
	if(count($keywords)):
	?><meta name="keywords" content="<?=implode(", ", $keywords)?>"><?php
	endif;
}

add_action("header_end", "\masterTheme\mt_body_navigation");
function mt_body_navigation(){
	
	global $wp;
    $request = stripslashes(urldecode($wp->request));
    $safeRequest;
    preg_match("/^[\w\d\-_.?\/# ]+$/", $request, $safeRequest, PREG_UNMATCHED_AS_NULL);
    $safeRequest = $safeRequest[0] ?? "";
	
	
	$navigationLinks = apply_filters("theme_navigation_links", array()) ?: array();
	
	if(count($navigationLinks)):
		$navigationKeys = array_keys(($navigationLinks));
		$currentSlug = $safeRequest;
		?><nav class="bgB"><section><ul><?php
		for($i=0; $i<count($navigationKeys); $i++):
			$link = $navigationLinks[$navigationKeys[$i]];
		?><li<?= $safeRequest == $link->slug ? " class=\"current\"" : "";?>><a href="<?=$link->slug?>"><?=$link->name?></a></li><?php
			
		endfor;
		?></ul></section></nav><?php
	endif;
	
}